package cn.iocoder.yudao.module.bpm.service.task;

package ..deTemp.1750667153708;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.LocalDateTimeUtil;
import cn.hutool.core.lang.Assert;
import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.BooleanUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.NumberUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.extra.spring.SpringUtil;
import cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.collection.CollectionUtils;
import cn.iocoder.yudao.framework.common.util.date.DateUtils;
import cn.iocoder.yudao.framework.common.util.number.NumberUtils;
import cn.iocoder.yudao.framework.common.util.object.PageUtils;
import cn.iocoder.yudao.framework.datapermission.core.annotation.DataPermission;
import cn.iocoder.yudao.framework.web.core.util.WebFrameworkUtils;
import cn.iocoder.yudao.module.bpm.controller.admin.definition.vo.model.BpmModelMetaInfoVO;
import cn.iocoder.yudao.module.bpm.controller.admin.task.vo.task.BpmTaskApproveReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.task.vo.task.BpmTaskCopyReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.task.vo.task.BpmTaskDelegateReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.task.vo.task.BpmTaskPageReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.task.vo.task.BpmTaskRejectReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.task.vo.task.BpmTaskRespVO;
import cn.iocoder.yudao.module.bpm.controller.admin.task.vo.task.BpmTaskReturnReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.task.vo.task.BpmTaskSignCreateReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.task.vo.task.BpmTaskSignDeleteReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.task.vo.task.BpmTaskTransferReqVO;
import cn.iocoder.yudao.module.bpm.convert.task.BpmTaskConvert;
import cn.iocoder.yudao.module.bpm.dal.dataobject.definition.BpmFormDO;
import cn.iocoder.yudao.module.bpm.dal.dataobject.definition.BpmProcessDefinitionInfoDO;
import cn.iocoder.yudao.module.bpm.enums.ErrorCodeConstants;
import cn.iocoder.yudao.module.bpm.enums.definition.BpmUserTaskRejectHandlerTypeEnum;
import cn.iocoder.yudao.module.bpm.enums.definition.BpmUserTaskTimeoutHandlerTypeEnum;
import cn.iocoder.yudao.module.bpm.enums.task.BpmCommentTypeEnum;
import cn.iocoder.yudao.module.bpm.enums.task.BpmReasonEnum;
import cn.iocoder.yudao.module.bpm.enums.task.BpmTaskEventTypeEnum;
import cn.iocoder.yudao.module.bpm.enums.task.BpmTaskSignTypeEnum;
import cn.iocoder.yudao.module.bpm.enums.task.BpmTaskStatusEnum;
import cn.iocoder.yudao.module.bpm.event.BpmTaskEvent;
import cn.iocoder.yudao.module.bpm.framework.flowable.core.enums.BpmTaskCandidateStrategyEnum;
import cn.iocoder.yudao.module.bpm.framework.flowable.core.event.BpmTaskEventPublisher;
import cn.iocoder.yudao.module.bpm.framework.flowable.core.util.BpmHttpRequestUtils;
import cn.iocoder.yudao.module.bpm.framework.flowable.core.util.BpmnModelUtils;
import cn.iocoder.yudao.module.bpm.framework.flowable.core.util.FlowableUtils;
import cn.iocoder.yudao.module.bpm.service.definition.BpmFormService;
import cn.iocoder.yudao.module.bpm.service.definition.BpmModelService;
import cn.iocoder.yudao.module.bpm.service.definition.BpmProcessDefinitionService;
import cn.iocoder.yudao.module.bpm.service.message.BpmMessageService;
import cn.iocoder.yudao.module.bpm.service.message.dto.BpmMessageSendWhenTaskTimeoutReqDTO;
import cn.iocoder.yudao.module.bpm.service.task.BpmProcessInstanceCopyService;
import cn.iocoder.yudao.module.bpm.service.task.BpmProcessInstanceService;
import cn.iocoder.yudao.module.bpm.service.task.BpmTaskService;
import cn.iocoder.yudao.module.system.api.dept.DeptApi;
import cn.iocoder.yudao.module.system.api.user.AdminUserApi;
import cn.iocoder.yudao.module.system.api.user.dto.AdminUserRespDTO;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Stack;
import java.util.stream.Stream;
import javax.annotation.Resource;
import javax.validation.Valid;
import lombok.Generated;
import org.flowable.bpmn.model.BaseElement;
import org.flowable.bpmn.model.BpmnModel;
import org.flowable.bpmn.model.EndEvent;
import org.flowable.bpmn.model.FlowElement;
import org.flowable.bpmn.model.FlowNode;
import org.flowable.bpmn.model.UserTask;
import org.flowable.engine.HistoryService;
import org.flowable.engine.ManagementService;
import org.flowable.engine.RuntimeService;
import org.flowable.engine.TaskService;
import org.flowable.engine.history.HistoricActivityInstance;
import org.flowable.engine.history.HistoricActivityInstanceQuery;
import org.flowable.engine.runtime.ActivityInstance;
import org.flowable.engine.runtime.Execution;
import org.flowable.engine.runtime.ProcessInstance;
import org.flowable.task.api.DelegationState;
import org.flowable.task.api.NativeTaskQuery;
import org.flowable.task.api.Task;
import org.flowable.task.api.TaskInfo;
import org.flowable.task.api.TaskQuery;
import org.flowable.task.api.history.HistoricTaskInstance;
import org.flowable.task.api.history.HistoricTaskInstanceQuery;
import org.flowable.task.service.history.NativeHistoricTaskInstanceQuery;
import org.flowable.task.service.impl.persistence.entity.TaskEntity;
import org.flowable.task.service.impl.persistence.entity.TaskEntityImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.support.TransactionSynchronization;
import org.springframework.transaction.support.TransactionSynchronizationManager;

@Service
public class BpmTaskServiceImpl implements BpmTaskService {
  @Generated
  private static final Logger log = LoggerFactory.getLogger(cn.iocoder.yudao.module.bpm.service.task.BpmTaskServiceImpl.class);
  
  @Resource
  private TaskService taskService;
  
  @Resource
  private HistoryService historyService;
  
  @Resource
  private RuntimeService runtimeService;
  
  @Resource
  private ManagementService managementService;
  
  @Resource
  private BpmProcessInstanceService processInstanceService;
  
  @Resource
  private BpmProcessDefinitionService bpmProcessDefinitionService;
  
  @Resource
  private BpmProcessInstanceCopyService processInstanceCopyService;
  
  @Resource
  private BpmModelService modelService;
  
  @Resource
  private BpmMessageService messageService;
  
  @Resource
  private BpmFormService formService;
  
  @Resource
  private AdminUserApi adminUserApi;
  
  @Resource
  private DeptApi deptApi;
  
  @Resource
  @Lazy
  private BpmTaskEventPublisher bpmTaskEventPublisher;
  
  public PageResult<Task> getTaskTodoPage(Long userId, BpmTaskPageReqVO pageVO) {
    TaskQuery taskQuery = (TaskQuery)((TaskQuery)((TaskQuery)((TaskQuery)this.taskService.createTaskQuery().taskAssignee(String.valueOf(userId))).active().includeProcessVariables()).orderByTaskCreateTime()).desc();
    if (StrUtil.isNotBlank(pageVO.getName()))
      taskQuery.taskNameLike("%" + pageVO.getName() + "%"); 
    if (StrUtil.isNotEmpty(pageVO.getCategory()))
      taskQuery.taskCategory(pageVO.getCategory()); 
    if (StrUtil.isNotEmpty(pageVO.getProcessDefinitionKey()))
      taskQuery.processDefinitionKey(pageVO.getProcessDefinitionKey()); 
    if (ArrayUtil.isNotEmpty((Object[])pageVO.getCreateTime())) {
      taskQuery.taskCreatedAfter(DateUtils.of(pageVO.getCreateTime()[0]));
      taskQuery.taskCreatedBefore(DateUtils.of(pageVO.getCreateTime()[1]));
    } 
    long count = taskQuery.count();
    if (count == 0L)
      return PageResult.empty(); 
    List<Task> tasks = taskQuery.listPage(PageUtils.getStart((PageParam)pageVO), pageVO.getPageSize().intValue());
    return new PageResult(tasks, Long.valueOf(count));
  }
  
  public BpmTaskRespVO getTodoTask(Long userId, String taskId, String processInstanceId) {
    Task todoTask = getMyTodoTask(userId, taskId);
    if (todoTask == null)
      todoTask = getMyFirstTodoTask(userId, processInstanceId); 
    if (todoTask == null)
      return null; 
    List<Task> childrenTasks = getAllChildrenTaskListByParentTaskId(todoTask.getId(), CollUtil.newArrayList((Object[])new Task[] { todoTask }));
    BpmnModel bpmnModel = this.bpmProcessDefinitionService.getProcessDefinitionBpmnModel(todoTask.getProcessDefinitionId());
    Map<Integer, BpmTaskRespVO.OperationButtonSetting> buttonsSetting = BpmnModelUtils.parseButtonsSetting(bpmnModel, todoTask
        .getTaskDefinitionKey());
    Boolean signEnable = BpmnModelUtils.parseSignEnable(bpmnModel, todoTask.getTaskDefinitionKey());
    Boolean reasonRequire = BpmnModelUtils.parseReasonRequire(bpmnModel, todoTask.getTaskDefinitionKey());
    Integer nodeType = BpmnModelUtils.parseNodeType(BpmnModelUtils.getFlowElementById(bpmnModel, todoTask.getTaskDefinitionKey()));
    BpmFormDO taskForm = null;
    if (StrUtil.isNotBlank(todoTask.getFormKey()))
      taskForm = this.formService.getForm(NumberUtils.parseLong(todoTask.getFormKey())); 
    return BpmTaskConvert.INSTANCE.buildTodoTask(todoTask, childrenTasks, buttonsSetting, taskForm)
      .setNodeType(nodeType).setSignEnable(signEnable).setReasonRequire(reasonRequire);
  }
  
  private Task getMyTodoTask(Long userId, String taskId) {
    if (StrUtil.isEmpty(taskId))
      return null; 
    Task task = getTask(taskId);
    if (task == null)
      return null; 
    if (!isAssignUserTask(userId, task) && !isAddSignUserTask(userId, task))
      return null; 
    return task;
  }
  
  private Task getMyFirstTodoTask(Long userId, String processInstanceId) {
    if (processInstanceId == null)
      return null; 
    List<Task> tasks = ((TaskQuery)((TaskQuery)((TaskQuery)((TaskQuery)((TaskQuery)this.taskService.createTaskQuery().active().processInstanceId(processInstanceId)).includeTaskLocalVariables()).includeProcessVariables()).orderByTaskCreateTime()).asc()).list();
    return (Task)CollUtil.findOne(tasks, task -> 
        (isAssignUserTask(userId, task) || isAddSignUserTask(userId, task)));
  }
  
  public PageResult<HistoricTaskInstance> getTaskDonePage(Long userId, BpmTaskPageReqVO pageVO) {
    StringBuilder whereSql = new StringBuilder();
    if (userId != null)
      whereSql.append(" AND RES.ASSIGNEE_ = '").append(userId).append("' "); 
    if (StrUtil.isNotBlank(pageVO.getName()))
      whereSql.append(" AND RES.NAME_ LIKE '%").append(pageVO.getName()).append("%' "); 
    if (ArrayUtil.isNotEmpty((Object[])pageVO.getCreateTime()))
      whereSql.append(" AND ( RES.START_TIME_ BETWEEN '")
        .append(LocalDateTimeUtil.format(pageVO.getCreateTime()[0], "yyyy-MM-dd HH:mm:ss"))
        .append("' AND '")
        .append(LocalDateTimeUtil.format(pageVO.getCreateTime()[1], "yyyy-MM-dd HH:mm:ss"))
        .append("') "); 
    String countSql = "SELECT count( DISTINCT RES.PROC_INST_ID_ ) FROM ACT_HI_TASKINST RES WHERE RES.END_TIME_ IS NOT NULL AND RES.TASK_DEF_KEY_ <> 'StartUserNode' AND RES.TASK_DEF_KEY_ <> 'StartUserEndNode'" + whereSql;
    String sql = "SELECT RES.* FROM ACT_HI_TASKINST RES WHERE RES.END_TIME_ IS NOT NULL AND RES.TASK_DEF_KEY_ <> 'StartUserNode' AND RES.TASK_DEF_KEY_ <> 'StartUserEndNode'" + whereSql + "GROUP BY RES.PROC_INST_ID_ ORDER BY RES.END_TIME_ DESC ";
    long count = ((NativeHistoricTaskInstanceQuery)this.historyService.createNativeHistoricTaskInstanceQuery().sql(countSql)).count();
    if (count == 0L)
      return PageResult.empty(); 
    List<HistoricTaskInstance> tasks = ((NativeHistoricTaskInstanceQuery)this.historyService.createNativeHistoricTaskInstanceQuery().sql(sql)).listPage(PageUtils.getStart((PageParam)pageVO), pageVO.getPageSize().intValue());
    return new PageResult(tasks, Long.valueOf(count));
  }
  
  public PageResult<HistoricTaskInstance> getTaskPage(Long userId, BpmTaskPageReqVO pageVO) {
    HistoricTaskInstanceQuery taskQuery = (HistoricTaskInstanceQuery)((HistoricTaskInstanceQuery)((HistoricTaskInstanceQuery)this.historyService.createHistoricTaskInstanceQuery().includeTaskLocalVariables()).taskTenantId(FlowableUtils.getTenantId())).orderByHistoricTaskInstanceEndTime().desc();
    if (StrUtil.isNotBlank(pageVO.getName()))
      taskQuery.taskNameLike("%" + pageVO.getName() + "%"); 
    if (StrUtil.isNotEmpty(pageVO.getCategory()))
      taskQuery.taskCategory(pageVO.getCategory()); 
    if (ArrayUtil.isNotEmpty((Object[])pageVO.getCreateTime())) {
      taskQuery.taskCreatedAfter(DateUtils.of(pageVO.getCreateTime()[0]));
      taskQuery.taskCreatedBefore(DateUtils.of(pageVO.getCreateTime()[1]));
    } 
    long count = taskQuery.count();
    if (count == 0L)
      return PageResult.empty(); 
    List<HistoricTaskInstance> tasks = taskQuery.listPage(PageUtils.getStart((PageParam)pageVO), pageVO.getPageSize().intValue());
    return new PageResult(tasks, Long.valueOf(count));
  }
  
  public List<Task> getTasksByProcessInstanceIds(List<String> processInstanceIds) {
    if (CollUtil.isEmpty(processInstanceIds))
      return Collections.emptyList(); 
    return ((TaskQuery)this.taskService.createTaskQuery().processInstanceIdIn(processInstanceIds)).list();
  }
  
  public List<HistoricTaskInstance> getTaskListByProcessInstanceId(String processInstanceId, Boolean asc) {
    HistoricTaskInstanceQuery query = (HistoricTaskInstanceQuery)((HistoricTaskInstanceQuery)this.historyService.createHistoricTaskInstanceQuery().includeTaskLocalVariables()).processInstanceId(processInstanceId);
    if (Boolean.TRUE.equals(asc)) {
      query.orderByHistoricTaskInstanceStartTime().asc();
    } else {
      query.orderByHistoricTaskInstanceStartTime().desc();
    } 
    return query.list();
  }
  
  public Task validateTask(Long userId, String taskId) {
    Task task = validateTaskExist(taskId);
    if (StrUtil.isNotBlank(task.getAssignee()) && 
      ObjectUtil.notEqual(userId, NumberUtils.parseLong(task.getAssignee())))
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_OPERATE_FAIL_ASSIGN_NOT_SELF); 
    return task;
  }
  
  private Task validateTaskExist(String id) {
    Task task = getTask(id);
    if (task == null)
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_NOT_EXISTS); 
    return task;
  }
  
  public Task getTask(String id) {
    return (Task)((TaskQuery)((TaskQuery)this.taskService.createTaskQuery().taskId(id)).includeTaskLocalVariables()).singleResult();
  }
  
  public HistoricTaskInstance getHistoricTask(String id) {
    return (HistoricTaskInstance)((HistoricTaskInstanceQuery)((HistoricTaskInstanceQuery)this.historyService.createHistoricTaskInstanceQuery().taskId(id)).includeTaskLocalVariables()).singleResult();
  }
  
  public List<HistoricTaskInstance> getHistoricTasks(Collection<String> taskIds) {
    return ((HistoricTaskInstanceQuery)((HistoricTaskInstanceQuery)this.historyService.createHistoricTaskInstanceQuery().taskIds(taskIds)).includeTaskLocalVariables()).list();
  }
  
  public List<Task> getRunningTaskListByProcessInstanceId(String processInstanceId, Boolean assigned, String defineKey) {
    Assert.notNull(processInstanceId, "processInstanceId 不能为空", new Object[0]);
    TaskQuery taskQuery = (TaskQuery)((TaskQuery)this.taskService.createTaskQuery().processInstanceId(processInstanceId)).active().includeTaskLocalVariables();
    if (BooleanUtil.isTrue(assigned)) {
      taskQuery.taskAssigned();
    } else if (BooleanUtil.isFalse(assigned)) {
      taskQuery.taskUnassigned();
    } 
    if (StrUtil.isNotEmpty(defineKey))
      taskQuery.taskDefinitionKey(defineKey); 
    return taskQuery.list();
  }
  
  public List<UserTask> getUserTaskListByReturn(String id) {
    Task task = validateTaskExist(id);
    BpmnModel bpmnModel = this.modelService.getBpmnModelByDefinitionId(task.getProcessDefinitionId());
    FlowElement source = BpmnModelUtils.getFlowElementById(bpmnModel, task.getTaskDefinitionKey());
    if (source == null)
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_NOT_EXISTS); 
    List<UserTask> previousUserList = BpmnModelUtils.getPreviousUserTaskList(source, null, null);
    if (CollUtil.isEmpty(previousUserList))
      return Collections.emptyList(); 
    previousUserList.removeIf(userTask -> !BpmnModelUtils.isSequentialReachable(source, (FlowElement)userTask, null));
    return previousUserList;
  }
  
  public <T extends TaskInfo> List<T> getAllChildrenTaskListByParentTaskId(String parentTaskId, List<T> tasks) {
    if (CollUtil.isEmpty(tasks))
      return Collections.emptyList(); 
    Map<String, List<T>> parentTaskMap = CollectionUtils.convertMultiMap(
        CollectionUtils.filterList(tasks, task -> StrUtil.isNotEmpty(task.getParentTaskId())), TaskInfo::getParentTaskId);
    if (CollUtil.isEmpty(parentTaskMap))
      return Collections.emptyList(); 
    List<T> result = new ArrayList<>();
    Stack<String> stack = new Stack<>();
    stack.push(parentTaskId);
    for (int i = 0; i < 32767 && 
      !stack.isEmpty(); i++) {
      String taskId = stack.pop();
      List<T> childTaskList = CollectionUtils.filterList(tasks, task -> StrUtil.equals(task.getParentTaskId(), taskId));
      if (CollUtil.isNotEmpty(childTaskList)) {
        stack.addAll(CollectionUtils.convertList(childTaskList, TaskInfo::getId));
        result.addAll(childTaskList);
      } 
    } 
    return result;
  }
  
  private List<Task> getAllChildTaskList(Task parentTask) {
    List<Task> result = new ArrayList<>();
    Stack<Task> stack = new Stack<>();
    stack.push(parentTask);
    for (int i = 0; i < 32767 && 
      !stack.isEmpty(); i++) {
      Task task = stack.pop();
      List<Task> childTaskList = getTaskListByParentTaskId(task.getId());
      if (CollUtil.isNotEmpty(childTaskList)) {
        stack.addAll(childTaskList);
        result.addAll(childTaskList);
      } 
    } 
    return result;
  }
  
  public List<Task> getTaskListByParentTaskId(String parentTaskId) {
    String tableName = this.managementService.getTableName(TaskEntity.class);
    String sql = "select ID_,NAME_,OWNER_,ASSIGNEE_ from " + tableName + " where PARENT_TASK_ID_=#{parentTaskId}";
    return ((NativeTaskQuery)((NativeTaskQuery)this.taskService.createNativeTaskQuery().sql(sql)).parameter("parentTaskId", parentTaskId)).list();
  }
  
  private Long getTaskCountByParentTaskId(String parentTaskId) {
    String tableName = this.managementService.getTableName(TaskEntity.class);
    String sql = "SELECT COUNT(1) from " + tableName + " WHERE PARENT_TASK_ID_=#{parentTaskId}";
    return Long.valueOf(((NativeTaskQuery)((NativeTaskQuery)this.taskService.createNativeTaskQuery().sql(sql)).parameter("parentTaskId", parentTaskId)).count());
  }
  
  private String getTaskRootParentId(Task task) {
    if (task == null || task.getParentTaskId() == null)
      return null; 
    for (int i = 0; i < 32767; i++) {
      Task parentTask = getTask(task.getParentTaskId());
      if (parentTask == null)
        return null; 
      if (parentTask.getParentTaskId() == null)
        return parentTask.getId(); 
      task = parentTask;
    } 
    throw new IllegalArgumentException(String.format("Task(%s) 层级过深，无法获取父节点编号", new Object[] { task.getId() }));
  }
  
  public List<HistoricActivityInstance> getActivityListByProcessInstanceId(String processInstanceId) {
    return ((HistoricActivityInstanceQuery)this.historyService.createHistoricActivityInstanceQuery().processInstanceId(processInstanceId)
      .orderByHistoricActivityInstanceStartTime().asc()).list();
  }
  
  public List<HistoricActivityInstance> getHistoricActivityListByExecutionId(String executionId) {
    return this.historyService.createHistoricActivityInstanceQuery().executionId(executionId).list();
  }
  
  private boolean isAssignUserTask(Long userId, Task task) {
    Long assignee = NumberUtil.parseLong(task.getAssignee(), null);
    return ObjectUtil.equals(userId, assignee);
  }
  
  private boolean isOwnerUserTask(Long userId, Task task) {
    Long assignee = NumberUtil.parseLong(task.getOwner(), null);
    return ObjectUtil.equal(userId, assignee);
  }
  
  private boolean isAddSignUserTask(Long userId, Task task) {
    return ((isAssignUserTask(userId, task) || isOwnerUserTask(userId, task)) && 
      BpmTaskSignTypeEnum.of(task.getScopeType()) != null);
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void approveTask(Long userId, @Valid BpmTaskApproveReqVO reqVO) {
    Task task = validateTask(userId, reqVO.getId());
    ProcessInstance instance = this.processInstanceService.getProcessInstance(task.getProcessInstanceId());
    if (instance == null)
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.PROCESS_INSTANCE_NOT_EXISTS); 
    BpmnModel bpmnModel = this.modelService.getBpmnModelByDefinitionId(task.getProcessDefinitionId());
    Boolean signEnable = BpmnModelUtils.parseSignEnable(bpmnModel, task.getTaskDefinitionKey());
    if (signEnable.booleanValue() && StrUtil.isEmpty(reqVO.getSignPicUrl()))
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_SIGNATURE_NOT_EXISTS); 
    Boolean reasonRequire = BpmnModelUtils.parseReasonRequire(bpmnModel, task.getTaskDefinitionKey());
    if (reasonRequire.booleanValue() && StrUtil.isEmpty(reqVO.getReason()))
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_REASON_REQUIRE); 
    if (DelegationState.PENDING.equals(task.getDelegationState())) {
      approveDelegateTask(reqVO, task);
      return;
    } 
    if (BpmTaskSignTypeEnum.AFTER.getType().equals(task.getScopeType())) {
      approveAfterSignTask(task, reqVO);
      return;
    } 
    updateTaskStatusAndReason(task.getId(), BpmTaskStatusEnum.APPROVE.getStatus(), reqVO.getReason());
    if (signEnable.booleanValue())
      this.taskService.setVariableLocal(task.getId(), "TASK_SIGN_PIC_URL", reqVO.getSignPicUrl()); 
    this.taskService.addComment(task.getId(), task.getProcessInstanceId(), BpmCommentTypeEnum.APPROVE.getType(), BpmCommentTypeEnum.APPROVE
        .formatComment(new Object[] { reqVO.getReason() }));
    Map<String, Object> processVariables = new HashMap<>();
    if (CollUtil.isNotEmpty(instance.getProcessVariables()))
      processVariables.putAll(instance.getProcessVariables()); 
    if (CollUtil.isNotEmpty(reqVO.getVariables()))
      processVariables.putAll(reqVO.getVariables()); 
    Map<String, Object> variables = validateAndSetNextAssignees(task.getTaskDefinitionKey(), processVariables, bpmnModel, reqVO
        .getNextAssignees(), instance);
    this.runtimeService.setVariables(task.getProcessInstanceId(), variables);
    this.taskService.complete(task.getId(), variables, true);
    handleParentTaskIfSign(task.getParentTaskId());
  }
  
  private Map<String, Object> validateAndSetNextAssignees(String taskDefinitionKey, Map<String, Object> variables, BpmnModel bpmnModel, Map<String, List<Long>> nextAssignees, ProcessInstance processInstance) {
    if (Objects.equals(taskDefinitionKey, "StartUserNode"))
      return variables; 
    FlowElement flowElement = bpmnModel.getFlowElement(taskDefinitionKey);
    List<FlowNode> nextFlowNodes = BpmnModelUtils.getNextFlowNodes(flowElement, bpmnModel, variables);
    for (FlowNode nextFlowNode : nextFlowNodes) {
      Integer candidateStrategy = BpmnModelUtils.parseCandidateStrategy((FlowElement)nextFlowNode);
      if (ObjUtil.equals(candidateStrategy, BpmTaskCandidateStrategyEnum.START_USER_SELECT.getStrategy())) {
        Map<String, List<Long>> startUserSelectAssignees = FlowableUtils.getStartUserSelectAssignees(processInstance.getProcessVariables());
        if (startUserSelectAssignees != null && CollUtil.isNotEmpty(startUserSelectAssignees.get(nextFlowNode.getId())))
          continue; 
        List<Long> assignees = (nextAssignees != null) ? nextAssignees.get(nextFlowNode.getId()) : null;
        if (CollUtil.isEmpty(assignees))
          throw ServiceExceptionUtil.exception(ErrorCodeConstants.PROCESS_INSTANCE_START_USER_SELECT_ASSIGNEES_NOT_CONFIG, new Object[] { nextFlowNode.getName() }); 
        if (startUserSelectAssignees == null)
          startUserSelectAssignees = new HashMap<>(); 
        startUserSelectAssignees.put(nextFlowNode.getId(), assignees);
        variables.put("PROCESS_START_USER_SELECT_ASSIGNEES", startUserSelectAssignees);
        continue;
      } 
      if (ObjUtil.equals(candidateStrategy, BpmTaskCandidateStrategyEnum.APPROVE_USER_SELECT.getStrategy())) {
        Map<String, List<Long>> approveUserSelectAssignees = FlowableUtils.getApproveUserSelectAssignees(processInstance.getProcessVariables());
        List<Long> assignees = (nextAssignees != null) ? nextAssignees.get(nextFlowNode.getId()) : null;
        if (CollUtil.isEmpty(assignees))
          throw ServiceExceptionUtil.exception(ErrorCodeConstants.PROCESS_INSTANCE_APPROVE_USER_SELECT_ASSIGNEES_NOT_CONFIG, new Object[] { nextFlowNode.getName() }); 
        if (approveUserSelectAssignees == null)
          approveUserSelectAssignees = new HashMap<>(); 
        approveUserSelectAssignees.put(nextFlowNode.getId(), assignees);
        variables.put("PROCESS_APPROVE_USER_SELECT_ASSIGNEES", approveUserSelectAssignees);
      } 
    } 
    return variables;
  }
  
  private void approveAfterSignTask(Task task, BpmTaskApproveReqVO reqVO) {
    updateTaskStatusAndReason(task.getId(), BpmTaskStatusEnum.APPROVING.getStatus(), reqVO.getReason());
    List<Task> childrenTaskList = getTaskListByParentTaskId(task.getId());
    for (Task childrenTask : childrenTaskList) {
      this.taskService.resolveTask(childrenTask.getId());
      updateTaskStatus(childrenTask.getId(), BpmTaskStatusEnum.RUNNING.getStatus());
    } 
  }
  
  private void handleParentTaskIfSign(String parentTaskId) {
    if (StrUtil.isBlank(parentTaskId))
      return; 
    Long childrenTaskCount = getTaskCountByParentTaskId(parentTaskId);
    if (childrenTaskCount.longValue() > 0L)
      return; 
    Task parentTask = validateTaskExist(parentTaskId);
    String scopeType = parentTask.getScopeType();
    if (BpmTaskSignTypeEnum.of(scopeType) == null)
      return; 
    TaskEntityImpl parentTaskImpl = (TaskEntityImpl)parentTask;
    parentTaskImpl.setScopeType(null);
    this.taskService.saveTask((Task)parentTaskImpl);
    if (BpmTaskSignTypeEnum.BEFORE.getType().equals(scopeType)) {
      this.taskService.resolveTask(parentTaskId);
      updateTaskStatus(parentTaskId, BpmTaskStatusEnum.RUNNING.getStatus());
    } else if (BpmTaskSignTypeEnum.AFTER.getType().equals(scopeType)) {
      Integer status = (Integer)parentTask.getTaskLocalVariables().get("TASK_STATUS");
      if (ObjectUtil.notEqual(status, BpmTaskStatusEnum.APPROVING.getStatus()))
        return; 
      updateTaskStatus(parentTaskId, BpmTaskStatusEnum.APPROVE.getStatus());
      this.taskService.complete(parentTaskId);
    } 
    handleParentTaskIfSign(parentTask.getParentTaskId());
  }
  
  private void approveDelegateTask(BpmTaskApproveReqVO reqVO, Task task) {
    AdminUserRespDTO currentUser = this.adminUserApi.getUser(WebFrameworkUtils.getLoginUserId());
    AdminUserRespDTO ownerUser = this.adminUserApi.getUser(NumberUtils.parseLong(task.getOwner()));
    Assert.notNull(ownerUser, "委派任务找不到原审批人，需要检查数据", new Object[0]);
    this.taskService.addComment(reqVO.getId(), task.getProcessInstanceId(), BpmCommentTypeEnum.DELEGATE_END.getType(), BpmCommentTypeEnum.DELEGATE_END
        .formatComment(new Object[] { currentUser.getNickname(), ownerUser.getNickname(), reqVO.getReason() }));
    this.taskService.resolveTask(task.getId());
    updateTaskStatusAndReason(task.getId(), BpmTaskStatusEnum.RUNNING.getStatus(), reqVO.getReason());
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void rejectTask(Long userId, @Valid BpmTaskRejectReqVO reqVO) {
    Task task = validateTask(userId, reqVO.getId());
    ProcessInstance instance = this.processInstanceService.getProcessInstance(task.getProcessInstanceId());
    if (instance == null)
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.PROCESS_INSTANCE_NOT_EXISTS); 
    updateTaskStatusAndReason(task.getId(), BpmTaskStatusEnum.REJECT.getStatus(), reqVO.getReason());
    this.taskService.addComment(task.getId(), task.getProcessInstanceId(), BpmCommentTypeEnum.REJECT.getType(), BpmCommentTypeEnum.REJECT
        .formatComment(new Object[] { reqVO.getReason() }));
    if (task.getParentTaskId() != null) {
      String rootParentId = getTaskRootParentId(task);
      updateTaskStatusAndReason(rootParentId, BpmTaskStatusEnum.REJECT.getStatus(), BpmCommentTypeEnum.REJECT
          .formatComment(new Object[] { "加签任务不通过" }));
      this.taskService.addComment(rootParentId, task.getProcessInstanceId(), BpmCommentTypeEnum.REJECT.getType(), BpmCommentTypeEnum.REJECT
          .formatComment(new Object[] { "加签任务不通过" }));
    } 
    BpmnModel bpmnModel = this.modelService.getBpmnModelByDefinitionId(task.getProcessDefinitionId());
    FlowElement userTaskElement = BpmnModelUtils.getFlowElementById(bpmnModel, task.getTaskDefinitionKey());
    BpmUserTaskRejectHandlerTypeEnum userTaskRejectHandlerType = BpmnModelUtils.parseRejectHandlerType(userTaskElement);
    if (userTaskRejectHandlerType == BpmUserTaskRejectHandlerTypeEnum.RETURN_USER_TASK) {
      String returnTaskId = BpmnModelUtils.parseReturnTaskId(userTaskElement);
      Assert.notNull(returnTaskId, "退回的节点不能为空", new Object[0]);
      returnTask(userId, (new BpmTaskReturnReqVO()).setId(task.getId())
          .setTargetTaskDefinitionKey(returnTaskId).setReason(reqVO.getReason()));
      return;
    } 
    this.processInstanceService.updateProcessInstanceReject(instance, reqVO.getReason());
    moveTaskToEnd(task.getProcessInstanceId(), BpmCommentTypeEnum.REJECT.formatComment(new Object[] { reqVO.getReason() }));
  }
  
  private void updateTaskStatus(String id, Integer status) {
    this.taskService.setVariableLocal(id, "TASK_STATUS", status);
  }
  
  private void updateTaskStatusAndReason(String id, Integer status, String reason) {
    updateTaskStatus(id, status);
    this.taskService.setVariableLocal(id, "TASK_REASON", reason);
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void returnTask(Long userId, BpmTaskReturnReqVO reqVO) {
    Task task = validateTask(userId, reqVO.getId());
    if (task.isSuspended())
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_IS_PENDING); 
    FlowElement targetElement = validateTargetTaskCanReturn(task.getTaskDefinitionKey(), reqVO
        .getTargetTaskDefinitionKey(), task.getProcessDefinitionId());
    returnTask(userId, task, targetElement, reqVO);
  }
  
  private FlowElement validateTargetTaskCanReturn(String sourceKey, String targetKey, String processDefinitionId) {
    BpmnModel bpmnModel = this.modelService.getBpmnModelByDefinitionId(processDefinitionId);
    FlowElement source = BpmnModelUtils.getFlowElementById(bpmnModel, sourceKey);
    FlowElement target = BpmnModelUtils.getFlowElementById(bpmnModel, targetKey);
    if (target == null)
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_TARGET_NODE_NOT_EXISTS); 
    if (!BpmnModelUtils.isSequentialReachable(source, target, null))
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_RETURN_FAIL_SOURCE_TARGET_ERROR); 
    return target;
  }
  
  public void returnTask(Long userId, Task currentTask, FlowElement targetElement, BpmTaskReturnReqVO reqVO) {
    List<Task> taskList = ((TaskQuery)this.taskService.createTaskQuery().processInstanceId(currentTask.getProcessInstanceId())).list();
    List<String> runTaskKeyList = CollectionUtils.convertList(taskList, TaskInfo::getTaskDefinitionKey);
    List<UserTask> returnUserTaskList = BpmnModelUtils.iteratorFindChildUserTasks(targetElement, runTaskKeyList, null, null);
    List<String> returnTaskKeyList = CollectionUtils.convertList(returnUserTaskList, BaseElement::getId);
    List<String> runExecutionIds = new ArrayList<>();
    taskList.forEach(task -> {
          if (!returnTaskKeyList.contains(task.getTaskDefinitionKey()))
            return; 
          runExecutionIds.add(task.getExecutionId());
          if (isAssignUserTask(userId, task)) {
            this.taskService.addComment(task.getId(), currentTask.getProcessInstanceId(), BpmCommentTypeEnum.RETURN.getType(), BpmCommentTypeEnum.RETURN.formatComment(new Object[] { reqVO.getReason() }));
            updateTaskStatusAndReason(task.getId(), BpmTaskStatusEnum.RETURN.getStatus(), reqVO.getReason());
          } else {
            processTaskCanceled(task.getId());
          } 
        });
    this.runtimeService.setVariable(currentTask.getProcessInstanceId(), 
        String.format("RETURN_FLAG_%s", new Object[] { reqVO.getTargetTaskDefinitionKey() }), Boolean.TRUE);
    this.runtimeService.createChangeActivityStateBuilder()
      .processInstanceId(currentTask.getProcessInstanceId())
      .moveExecutionsToSingleActivityId(runExecutionIds, reqVO.getTargetTaskDefinitionKey())
      .changeState();
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void delegateTask(Long userId, BpmTaskDelegateReqVO reqVO) {
    String taskId = reqVO.getId();
    Task task = validateTask(userId, reqVO.getId());
    if (task.getAssignee().equals(reqVO.getDelegateUserId().toString()))
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_DELEGATE_FAIL_USER_REPEAT); 
    AdminUserRespDTO delegateUser = this.adminUserApi.getUser(reqVO.getDelegateUserId());
    if (delegateUser == null)
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_DELEGATE_FAIL_USER_NOT_EXISTS); 
    AdminUserRespDTO currentUser = this.adminUserApi.getUser(userId);
    this.taskService.addComment(taskId, task.getProcessInstanceId(), BpmCommentTypeEnum.DELEGATE_START.getType(), BpmCommentTypeEnum.DELEGATE_START
        .formatComment(new Object[] { currentUser.getNickname(), delegateUser.getNickname(), reqVO.getReason() }));
    this.taskService.setOwner(taskId, task.getAssignee());
    this.taskService.delegateTask(taskId, reqVO.getDelegateUserId().toString());
  }
  
  public void transferTask(Long userId, BpmTaskTransferReqVO reqVO) {
    String taskId = reqVO.getId();
    Task task = validateTask(userId, reqVO.getId());
    if (task.getAssignee().equals(reqVO.getAssigneeUserId().toString()))
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_TRANSFER_FAIL_USER_REPEAT); 
    AdminUserRespDTO assigneeUser = this.adminUserApi.getUser(reqVO.getAssigneeUserId());
    if (assigneeUser == null)
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_TRANSFER_FAIL_USER_NOT_EXISTS); 
    AdminUserRespDTO currentUser = this.adminUserApi.getUser(userId);
    this.taskService.addComment(taskId, task.getProcessInstanceId(), BpmCommentTypeEnum.TRANSFER.getType(), BpmCommentTypeEnum.TRANSFER
        .formatComment(new Object[] { currentUser.getNickname(), assigneeUser.getNickname(), reqVO.getReason() }));
    this.taskService.setOwner(taskId, task.getAssignee());
    this.taskService.setAssignee(taskId, reqVO.getAssigneeUserId().toString());
  }
  
  public void moveTaskToEnd(String processInstanceId, String reason) {
    List<Task> taskList = getRunningTaskListByProcessInstanceId(processInstanceId, null, null);
    if (CollUtil.isEmpty(taskList))
      return; 
    taskList.forEach(task -> {
          Integer otherTaskStatus = (Integer)task.getTaskLocalVariables().get("TASK_STATUS");
          if (BpmTaskStatusEnum.isEndStatus(otherTaskStatus))
            return; 
          processTaskCanceled(task.getId());
        });
    BpmnModel bpmnModel = this.modelService.getBpmnModelByDefinitionId(((Task)taskList.get(0)).getProcessDefinitionId());
    List<String> activityIds = CollUtil.newArrayList(CollectionUtils.convertSet(taskList, TaskInfo::getTaskDefinitionKey));
    EndEvent endEvent = BpmnModelUtils.getEndEvent(bpmnModel);
    Assert.notNull(endEvent, "结束节点不能为空", new Object[0]);
    this.runtimeService.createChangeActivityStateBuilder()
      .processInstanceId(processInstanceId)
      .moveActivityIdsToSingleActivityId(activityIds, endEvent.getId())
      .changeState();
    List<Execution> executions = this.runtimeService.createExecutionQuery().processInstanceId(processInstanceId).list();
    if (CollUtil.isNotEmpty(executions)) {
      log.warn("[moveTaskToEnd][执行跳转到 EndEvent 后, 流程实例未结束，强制执行 deleteProcessInstance 方法]");
      this.runtimeService.deleteProcessInstance(processInstanceId, reason);
    } 
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void createSignTask(Long userId, BpmTaskSignCreateReqVO reqVO) {
    TaskEntityImpl taskEntity = validateTaskCanCreateSign(userId, reqVO);
    List<AdminUserRespDTO> userList = this.adminUserApi.getUserList(reqVO.getUserIds());
    if (CollUtil.isEmpty(userList))
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_SIGN_CREATE_USER_NOT_EXIST); 
    taskEntity.setCountEnabled(true);
    if (reqVO.getType().equals(BpmTaskSignTypeEnum.BEFORE.getType())) {
      taskEntity.setOwner(taskEntity.getAssignee());
      taskEntity.setAssignee(null);
    } 
    taskEntity.setScopeType(reqVO.getType());
    this.taskService.saveTask((Task)taskEntity);
    if (reqVO.getType().equals(BpmTaskSignTypeEnum.BEFORE.getType()))
      updateTaskStatus(taskEntity.getId(), BpmTaskStatusEnum.WAIT.getStatus()); 
    createSignTaskList(CollectionUtils.convertList(reqVO.getUserIds(), String::valueOf), taskEntity);
    AdminUserRespDTO currentUser = this.adminUserApi.getUser(userId);
    String comment = StrUtil.format(BpmCommentTypeEnum.ADD_SIGN.getComment(), new Object[] { currentUser
          .getNickname(), BpmTaskSignTypeEnum.nameOfType(reqVO.getType()), 
          String.join(",", CollectionUtils.convertList(userList, AdminUserRespDTO::getNickname)), reqVO.getReason() });
    this.taskService.addComment(reqVO.getId(), taskEntity.getProcessInstanceId(), BpmCommentTypeEnum.ADD_SIGN.getType(), comment);
  }
  
  private TaskEntityImpl validateTaskCanCreateSign(Long userId, BpmTaskSignCreateReqVO reqVO) {
    TaskEntityImpl taskEntity = (TaskEntityImpl)validateTask(userId, reqVO.getId());
    if (taskEntity.getScopeType() != null && 
      ObjectUtil.notEqual(taskEntity.getScopeType(), reqVO.getType()))
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_SIGN_CREATE_TYPE_ERROR, new Object[] { BpmTaskSignTypeEnum.nameOfType(taskEntity.getScopeType()), BpmTaskSignTypeEnum.nameOfType(reqVO.getType()) }); 
    List<Task> taskList = ((TaskQuery)((TaskQuery)this.taskService.createTaskQuery().processInstanceId(taskEntity.getProcessInstanceId())).taskDefinitionKey(taskEntity.getTaskDefinitionKey())).list();
    List<Long> currentAssigneeList = CollectionUtils.convertListByFlatMap(taskList, task -> Stream.of(new Long[] { NumberUtils.parseLong(task.getAssignee()), NumberUtils.parseLong(task.getOwner()) }));
    if (CollUtil.containsAny(currentAssigneeList, reqVO.getUserIds())) {
      List<AdminUserRespDTO> userList = this.adminUserApi.getUserList(CollUtil.intersection(currentAssigneeList, reqVO.getUserIds()));
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_SIGN_CREATE_USER_REPEAT, new Object[] { String.join(",", CollectionUtils.convertList(userList, AdminUserRespDTO::getNickname)) });
    } 
    return taskEntity;
  }
  
  private void createSignTaskList(List<String> userIds, TaskEntityImpl taskEntity) {
    if (CollUtil.isEmpty(userIds))
      return; 
    for (String addSignId : userIds) {
      if (StrUtil.isBlank(addSignId))
        continue; 
      createSignTask(taskEntity, addSignId);
    } 
  }
  
  private void createSignTask(TaskEntityImpl parentTask, String assignee) {
    TaskEntityImpl task = (TaskEntityImpl)this.taskService.newTask(IdUtil.fastSimpleUUID());
    BpmTaskConvert.INSTANCE.copyTo(parentTask, task);
    if (BpmTaskSignTypeEnum.BEFORE.getType().equals(parentTask.getScopeType())) {
      task.setAssignee(assignee);
    } else {
      task.setOwner(assignee);
    } 
    this.taskService.saveTask((Task)task);
    if (BpmTaskSignTypeEnum.AFTER.getType().equals(parentTask.getScopeType()))
      updateTaskStatus(task.getId(), BpmTaskStatusEnum.WAIT.getStatus()); 
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void deleteSignTask(Long userId, BpmTaskSignDeleteReqVO reqVO) {
    Task task = validateTaskCanSignDelete(reqVO.getId());
    AdminUserRespDTO cancelUser = null;
    if (StrUtil.isNotBlank(task.getAssignee()))
      cancelUser = this.adminUserApi.getUser(NumberUtils.parseLong(task.getAssignee())); 
    if (cancelUser == null && StrUtil.isNotBlank(task.getOwner()))
      cancelUser = this.adminUserApi.getUser(NumberUtils.parseLong(task.getOwner())); 
    Assert.notNull(cancelUser, "任务中没有所有者和审批人，数据错误", new Object[0]);
    List<Task> childTaskList = getAllChildTaskList(task);
    childTaskList.add(task);
    String cancelReason = StrUtil.format("任务被取消，原因：由于[{}]操作[减签]，", new Object[] { cancelUser.getNickname() });
    childTaskList.forEach(childTask -> updateTaskStatusAndReason(childTask.getId(), BpmTaskStatusEnum.CANCEL.getStatus(), cancelReason));
    this.taskService.deleteTasks(CollectionUtils.convertList(childTaskList, TaskInfo::getId));
    AdminUserRespDTO user = this.adminUserApi.getUser(userId);
    this.taskService.addComment(task.getParentTaskId(), task.getProcessInstanceId(), BpmCommentTypeEnum.SUB_SIGN.getType(), 
        StrUtil.format(BpmCommentTypeEnum.SUB_SIGN.getComment(), new Object[] { user.getNickname(), cancelUser.getNickname() }));
    handleParentTaskIfSign(task.getParentTaskId());
  }
  
  public void copyTask(Long userId, BpmTaskCopyReqVO reqVO) {
    this.processInstanceCopyService.createProcessInstanceCopy(reqVO.getCopyUserIds(), reqVO.getReason(), reqVO.getId());
  }
  
  private Task validateTaskCanSignDelete(String id) {
    Task task = validateTaskExist(id);
    if (task.getParentTaskId() == null)
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_SIGN_DELETE_NO_PARENT); 
    Task parentTask = getTask(task.getParentTaskId());
    if (parentTask == null)
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_SIGN_DELETE_NO_PARENT); 
    if (BpmTaskSignTypeEnum.of(parentTask.getScopeType()) == null)
      throw ServiceExceptionUtil.exception(ErrorCodeConstants.TASK_SIGN_DELETE_NO_PARENT); 
    return task;
  }
  
  public void processTaskCreated(Task task) {
    Integer status = (Integer)task.getTaskLocalVariables().get("TASK_STATUS");
    if (status != null) {
      log.error("[updateTaskStatusWhenCreated][taskId({}) 已经有状态({})]", task.getId(), status);
      return;
    } 
    updateTaskStatus(task.getId(), BpmTaskStatusEnum.RUNNING.getStatus());
    ProcessInstance processInstance = this.processInstanceService.getProcessInstance(task.getProcessInstanceId());
    if (processInstance == null) {
      log.error("[processTaskCreated][taskId({}) 没有找到流程实例]", task.getId());
      return;
    } 
    BpmProcessDefinitionInfoDO processDefinitionInfo = this.bpmProcessDefinitionService.getProcessDefinitionInfo(processInstance.getProcessDefinitionId());
    if (processDefinitionInfo == null) {
      log.error("[processTaskCreated][processDefinitionId({}) 没有找到流程定义]", processInstance.getProcessDefinitionId());
      return;
    } 
    if (ObjUtil.isNotNull(processDefinitionInfo.getTaskBeforeTriggerSetting())) {
      BpmModelMetaInfoVO.HttpRequestSetting setting = processDefinitionInfo.getTaskBeforeTriggerSetting();
      BpmHttpRequestUtils.executeBpmHttpRequest(processInstance, setting
          .getUrl(), setting.getHeader(), setting.getBody(), Boolean.valueOf(true), setting.getResponse());
    } 
    BpmnModel bpmnModel = this.modelService.getBpmnModelByDefinitionId(processInstance.getProcessDefinitionId());
    FlowElement userTaskElement = BpmnModelUtils.getFlowElementById(bpmnModel, task.getTaskDefinitionKey());
    Integer approveType = BpmnModelUtils.parseApproveType(userTaskElement);
    Integer assignEmptyHandlerType = BpmnModelUtils.parseAssignEmptyHandlerType(userTaskElement);
    Boolean submitted = Boolean.valueOf(Boolean.TRUE.equals(processInstance.getProcessVariables().get("submitted")));
    Boolean startUserTaskNode = Boolean.valueOf(Boolean.TRUE.equals(BpmnModelUtils.parseStartUserTaskNode(bpmnModel, task.getTaskDefinitionKey())));
    TransactionSynchronizationManager.registerSynchronization((TransactionSynchronization)new Object(this, task, submitted, startUserTaskNode, approveType, processInstance, assignEmptyHandlerType));
  }
  
  public void processTaskCanceled(String taskId) {
    Task task = getTask(taskId);
    if (task == null) {
      log.error("[updateTaskStatusWhenCanceled][taskId({}) 任务不存在]", taskId);
      return;
    } 
    Integer status = (Integer)task.getTaskLocalVariables().get("TASK_STATUS");
    if (BpmTaskStatusEnum.isEndStatus(status)) {
      log.error("[updateTaskStatusWhenCanceled][taskId({}) 处于结果({})，无需进行更新]", taskId, status);
      return;
    } 
    updateTaskStatusAndReason(taskId, BpmTaskStatusEnum.CANCEL.getStatus(), BpmReasonEnum.CANCEL_BY_SYSTEM.getReason());
  }
  
  @DataPermission(enable = false)
  public void processTaskAssigned(Task task) {
    TransactionSynchronizationManager.registerSynchronization((TransactionSynchronization)new Object(this, task));
  }
  
  public void processTaskCompleted(Task task) {
    ProcessInstance processInstance = this.processInstanceService.getProcessInstance(task.getProcessInstanceId());
    if (processInstance == null) {
      log.error("[processTaskCompleted][taskId({}) 没有找到流程实例]", task.getId());
      return;
    } 
    BpmProcessDefinitionInfoDO processDefinitionInfo = this.bpmProcessDefinitionService.getProcessDefinitionInfo(processInstance.getProcessDefinitionId());
    if (processDefinitionInfo == null) {
      log.error("[processTaskCompleted][processDefinitionId({}) 没有找到流程定义]", processInstance.getProcessDefinitionId());
      return;
    } 
    if (ObjUtil.isNotNull(processDefinitionInfo.getTaskAfterTriggerSetting())) {
      BpmModelMetaInfoVO.HttpRequestSetting setting = processDefinitionInfo.getTaskAfterTriggerSetting();
      BpmHttpRequestUtils.executeBpmHttpRequest(processInstance, setting
          .getUrl(), setting.getHeader(), setting.getBody(), Boolean.valueOf(true), setting.getResponse());
    } 
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void processTaskTimeout(String processInstanceId, String taskDefineKey, Integer handlerType) {
    ProcessInstance processInstance = this.processInstanceService.getProcessInstance(processInstanceId);
    if (processInstance == null) {
      log.error("[processTaskTimeout][processInstanceId({}) 没有找到流程实例]", processInstanceId);
      return;
    } 
    List<Task> taskList = getRunningTaskListByProcessInstanceId(processInstanceId, Boolean.valueOf(true), taskDefineKey);
    if (CollUtil.isEmpty(taskList)) {
      log.error("[processTaskTimeout][processInstanceId({}) 定义Key({}) 没有找到任务]", processInstanceId, taskDefineKey);
      return;
    } 
    taskList.forEach(task -> FlowableUtils.execute(task.getTenantId(), ()));
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void processChildProcessTimeout(String processInstanceId, String taskDefineKey) {
    List<ActivityInstance> activityInstances = this.runtimeService.createActivityInstanceQuery().processInstanceId(processInstanceId).activityId(taskDefineKey).list();
    activityInstances.forEach(activityInstance -> FlowableUtils.execute(activityInstance.getTenantId(), ()));
  }
  
  public void triggerTask(String processInstanceId, String taskDefineKey) {
    Execution execution = (Execution)this.runtimeService.createExecutionQuery().processInstanceId(processInstanceId).activityId(taskDefineKey).singleResult();
    if (execution == null) {
      log.error("[triggerTask][processInstanceId({}) activityId({}) 没有找到执行活动]", processInstanceId, taskDefineKey);
      return;
    } 
    FlowableUtils.execute(execution.getTenantId(), () -> this.runtimeService.trigger(execution.getId()));
  }
  
  private cn.iocoder.yudao.module.bpm.service.task.BpmTaskServiceImpl getSelf() {
    return (cn.iocoder.yudao.module.bpm.service.task.BpmTaskServiceImpl)SpringUtil.getBean(getClass());
  }
  
  private void sendTaskCreatedEvent(Object source, String assignee, Boolean editable, ProcessInstance processInstance) {
    BpmTaskEvent bpmTaskCreatedEvent = new BpmTaskEvent(source);
    bpmTaskCreatedEvent.setAssignee(assignee)
      .setEditable(editable)
      .setEventType(BpmTaskEventTypeEnum.CREATE.getType())
      .setBusinessKey(processInstance.getBusinessKey())
      .setProcessInstanceId(processInstance.getProcessInstanceId())
      .setProcessDefinitionKey((processInstance.getProcessDefinitionKey() == null) ? processInstance
        .getProcessDefinitionId().split(":")[0] : processInstance.getProcessDefinitionKey());
    this.bpmTaskEventPublisher.sendTaskEvent(bpmTaskCreatedEvent);
    log.info("[sendTaskCreatedEvent] 发送待审批人到业务表成功,业务主键{}", bpmTaskCreatedEvent.getBusinessKey());
  }
}
